import java.awt.*;

public class post extends java.applet.Applet
{
  
  TextField infix, postfix, rez;
  String inhold, posthold, rezhold;
  void buildConstraints(GridBagConstraints gbc, int gx, int gy,
       int gw, int gh, int wx, int wy)
  {
    gbc.gridx=gx;
    gbc.gridy=gy;
    gbc.gridheight=gh;
    gbc.gridwidth=gw;
    gbc.weightx=wx;
    gbc.weighty=wy;
    gbc.ipadx=5;
    gbc.ipady=5;
  }

  public void init()
  {
    GridBagLayout gridbag= new GridBagLayout();
    GridBagConstraints constraints = new GridBagConstraints();
    setLayout(gridbag);

    buildConstraints(constraints,0,0,1,1,10,20);
    Label lab1=new Label("Postfix salyga:",Label.RIGHT);
    constraints.fill = GridBagConstraints.BOTH;
    constraints.anchor=GridBagConstraints.CENTER;
    gridbag.setConstraints(lab1, constraints);
    add(lab1);

    postfix = new TextField("");
    buildConstraints(constraints,1,0,1,1,90,0);
    gridbag.setConstraints(postfix, constraints);
    add(postfix);
//------------------------------------------------------
    Label lab2=new Label("Paprasta algebrine:",Label.RIGHT);
    buildConstraints(constraints,0,1,1,1,0,20);
    gridbag.setConstraints(lab2, constraints);
    add(lab2);

    infix = new TextField("");
    buildConstraints(constraints,1,1,1,1,0,0);
    gridbag.setConstraints(infix, constraints);
    add(infix);
//------------------------------------------------------

    Label lab3=new Label("Postfix rezultatas:",Label.RIGHT);
    buildConstraints(constraints,0,2,1,1,0,20);
    gridbag.setConstraints(lab3, constraints);
    add(lab3);

    rez = new TextField("");
    buildConstraints(constraints,1,2,1,1,0,0);
    gridbag.setConstraints(rez, constraints);
    add(rez);
     
    rezhold=""; 
    inhold="";
    posthold="";
  }
  public boolean action(Event e, Object arg)
  {
    if (e.target instanceof TextField)
      return handleText();
    else
      return false;
  }
  
  boolean handleText()
  {
    String inF, postF, Rez;
   
    
    if (!posthold.equals(postfix.getText()))
    {
      postF = postfix.getText();
      posthold=postF;
      inF = post(postF);
      Rez= skaiciuojam(postF);
      
    }
   
    return true;
  }



  String post(String in)
  {
    String[] opr = new String[30];
    String nop;
    
    int i, count,numval,opsub;
    count=-1;
    
    for (i=0; i<in.length(); i++)
      {
        char ch = in.charAt(i);
        if (!((ch=='^') || (ch=='*') || (ch=='/') || (ch=='+') || (ch=='-')))
          {
            count++;
            opr[count]="" + ch;
          }
        else
          {
            numval=0;
            nop=")";
            opsub=count;
            while (numval<2)
              {
                if (!opr[opsub].equals(""))
                  {
                    numval++;
                    if (numval==1) nop= ch+opr[opsub]+nop;
                      else nop="("+opr[opsub] + nop;
                    opr[opsub]="";
                  }
                opsub--;
              }
            opr[count]=nop;
          }
       }
     infix.setText(opr[count]);
     inhold=opr[count];
     return inhold;
  }
//=====================================================================  

  


 class StackX
   {
     private int maxSize;
     private int[] stackArray;
     private int top;

     public StackX(int size)      
       {
        maxSize = size;
        stackArray = new int[maxSize];
        top = -1;
       }

     public void push(int j)     
      { stackArray[++top] = j; }

     public int pop()            
      { return stackArray[top--]; }

     public boolean isEmpty()    
      { return (top == -1); }

     public boolean isFull()     
      { return (top == maxSize-1); }

     public int size()           
      { return top+1; }
   }  

//laipsniui skaiciuoti skirta funkcija
  int laipsnis(int nu1, int nu2)
  {
  	int i=1;
  	int kof= nu1;
    
    if (nu2!=0){
        while (i<nu2 ){nu1 = nu1 * kof;i++;}
  	    return nu1;
  	  }
  	 else return 1;  
  }
  
  String skaiciuojam(String poststr)
  {
  	String jep=poststr;
  	StackX theStack;
  	
    theStack = new StackX(40);            
      char ch;
      int j;
      int num1, num2, interAns;

      for(j=0; j<jep.length(); j++)       
         {
         ch = jep.charAt(j);              
           
         if(ch >= '0' && ch <= '9')         
            theStack.push( (int)(ch-'0') ); 
         else                               
            {
            num2 = theStack.pop();          
            num1 = theStack.pop();
            switch(ch)                      
               {
               case '+':
                  interAns = num1 + num2;
                  break;
               case '-':
                  interAns = num1 - num2;
                  break;
               case '*':
                  interAns = num1 * num2;
                  break;
               case '/':
                  interAns = num1 / num2;
                  break;
               case '^':
                  interAns=laipsnis(num1,num2);
                  break;   
               default:
                  interAns = 0;
               }  
            theStack.push(interAns);        
            }
         }
      interAns = theStack.pop(); 	
  	
  	jep=Integer.toString(interAns);
  	rez.setText(jep);
  	rezhold=jep;
  	return jep;
  }
  
}
